clear all

kVec = (0:1:50)';

for II = 1:length(kVec);
    II
    k = kVec(II);
    c_k(II,1) = quad(@(x)myfun_n3(x,k),0,pi,1e-10);

    clear k temp denom
end

kVec = [-flipud(kVec(2:end));kVec];
c_k = [flipud(c_k);c_k(2:end)];

xVec = (-132:1/2^8:132)';

for II = 1:length(xVec)
    x = xVec(II);
    for JJ = 1:length(kVec)
        ck = c_k(JJ);
        k = kVec(JJ);
        xVal = x - k;
        if (xVal>=0)&(xVal<1)
            Bn = 1/6*xVal^3;
        elseif (xVal>=1)&(xVal<2)
            Bn = 2/3 - 2*xVal + 2*xVal^2 - 1/2*xVal^3;
        elseif (xVal>=2)&(xVal<3)
            xVal = 4-xVal;
            Bn = 2/3 - 2*xVal + 2*xVal^2 - 1/2*xVal^3;
        elseif (xVal>=3)&(xVal<4)
            xVal = 4-xVal;
            Bn = 1/6*xVal^3;
        else
            Bn = 0;
        end

        temp(JJ,1) = ck*Bn;
        clear ck k xVal Bn
    end
    phi(II,1) = sum(temp);
    clear temp
end
figure(1)
clf
plot(xVec,phi)
grid
keyboard

save test_data.mat phi xVec
