clear all

load test_data

temp = find(phi == max(abs(phi)));
xx = xVec-xVec(temp);
clear xVec temp

temp = find(xx == 2^7);
xx((temp):end) = [];
phi((temp):end) = [];
clear temp

temp = find(xx == -2^7);
xx(1:(temp-1)) = [];
phi(1:(temp-1)) = [];

xx1 = xx;
phi1 = phi;

clear phi xx

phi2 = phi1;
xx2 = xx1;
clear temp
temp = find(xx1 == 2^6);
wrapRight = phi1(temp:end);
xx2(temp:end) = [];
phi2(temp:end) = [];
temp = find(xx1 == -2^6);
wrapLeft = phi1(1:(temp-1));
xx2(1:(temp-1)) = [];
phi2(1:(temp-1)) = [];
phi2(1:length(wrapRight)) = phi2(1:length(wrapRight)) + wrapRight;
phi2((end-length(wrapLeft)+1):end) = phi2((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi3 = phi2;
xx3 = xx2;
clear temp
temp = find(xx2 == 2^5);
wrapRight = phi2(temp:end);
xx3(temp:end) = [];
phi3(temp:end) = [];
temp = find(xx2 == -2^5);
wrapLeft = phi2(1:(temp-1));
xx3(1:(temp-1)) = [];
phi3(1:(temp-1)) = [];
phi3(1:length(wrapRight)) = phi3(1:length(wrapRight)) + wrapRight;
phi3((end-length(wrapLeft)+1):end) = phi3((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi4 = phi3;
xx4 = xx3;
clear temp
temp = find(xx3 == 2^4);
wrapRight = phi3(temp:end);
xx4(temp:end) = [];
phi4(temp:end) = [];
temp = find(xx3 == -2^4);
wrapLeft = phi3(1:(temp-1));
xx4(1:(temp-1)) = [];
phi4(1:(temp-1)) = [];
phi4(1:length(wrapRight)) = phi4(1:length(wrapRight)) + wrapRight;
phi4((end-length(wrapLeft)+1):end) = phi4((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi5 = phi4;
xx5 = xx4;
clear temp
temp = find(xx4 == 2^3);
wrapRight = phi4(temp:end);
xx5(temp:end) = [];
phi5(temp:end) = [];
temp = find(xx4 == -2^3);
wrapLeft = phi4(1:(temp-1));
xx5(1:(temp-1)) = [];
phi5(1:(temp-1)) = [];
phi5(1:length(wrapRight)) = phi5(1:length(wrapRight)) + wrapRight;
phi5((end-length(wrapLeft)+1):end) = phi5((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi6 = phi5;
xx6 = xx5;
clear temp
temp = find(xx5 == 2^2);
wrapRight = phi5(temp:end);
xx6(temp:end) = [];
phi6(temp:end) = [];
temp = find(xx5 == -2^2);
wrapLeft = phi5(1:(temp-1));
xx6(1:(temp-1)) = [];
phi6(1:(temp-1)) = [];
phi6(1:length(wrapRight)) = phi6(1:length(wrapRight)) + wrapRight;
phi6((end-length(wrapLeft)+1):end) = phi6((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi7 = phi6;
xx7 = xx6;
clear temp
temp = find(xx6 == 2^1);
wrapRight = phi6(temp:end);
xx7(temp:end) = [];
phi7(temp:end) = [];
temp = find(xx6 == -2^1);
wrapLeft = phi6(1:(temp-1));
xx7(1:(temp-1)) = [];
phi7(1:(temp-1)) = [];
phi7(1:length(wrapRight)) = phi7(1:length(wrapRight)) + wrapRight;
phi7((end-length(wrapLeft)+1):end) = phi7((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

phi8 = phi7;
xx8 = xx7;
clear temp
temp = find(xx7 == 2^0);
wrapRight = phi7(temp:end);
xx8(temp:end) = [];
phi8(temp:end) = [];
temp = find(xx7 == -2^0);
wrapLeft = phi7(1:(temp-1));
xx8(1:(temp-1)) = [];
phi8(1:(temp-1)) = [];
phi8(1:length(wrapRight)) = phi8(1:length(wrapRight)) + wrapRight;
phi8((end-length(wrapLeft)+1):end) = phi8((end-length(wrapLeft)+1):end) + wrapLeft;
clear wrap*

% figure(1)
% clf
% subplot(4,2,1)
% plot(xx8,phi8)
% subplot(4,2,2)
% plot(xx7,phi7)
% subplot(4,2,3)
% plot(xx6,phi6)
% subplot(4,2,4)
% plot(xx5,phi5)
% subplot(4,2,5)
% plot(xx4,phi4)
% subplot(4,2,6)
% plot(xx3,phi3)
% subplot(4,2,7)
% plot(xx2,phi2)
% subplot(4,2,8)
% plot(xx1,phi1)


xStart = 0;
xStop = 1;
xInc = 1/2^10;
x = (xStart:xInc:(xStop-xInc))';

for II = 1:8
    eval(['P = phi' num2str(II) ';']);
    eval(['XX = xx' num2str(II) ';']);
    
    temp = length(P);
    nP = log10(temp)/log10(2);
    
    dxTemp = 1/2^nP;
    xTemp = (0:dxTemp:(1-dxTemp))';
    
    if nP < 10
        P = spline(xTemp,P,x); 
        xTemp = x;
    end
    
    for JJ = 1:length(x);
        PP(JJ,1) = P(find(xTemp == x(JJ)));
    end
    PP = PP/sqrt(xInc*dot(PP,PP));
    
    eval(['p' num2str(10-II) '=PP;']);
    clear temp nP dxTemp xTemp JJ PP P XX
end

p1 = ones(size(x));

clear xx* phi* 

for II = 1:9
    eval(['dataVec = p' num2str(II) ';'])
    for JJ = 1:2^(II-1)
        
        temp(:,JJ) = circshift(dataVec,(JJ-1)*2^(10-(II-1)));
    end
    eval(['P' num2str(II-1) '=temp;'])
    clear temp dataVec JJ
end


save Bspline_SF.mat P* x


