clear all

L = 10;
n = 0;          % derivative number
tot = 10;       % total number of points 2^tot

for J = 1:8
    tempStop = ceil(log10(L)/log10(2));
    tempInc = tot-J;
    
    x = (0:1/2^tempInc:(2^tempStop-1/2^tempInc))';
    phi = zeros(size(x));
    
    [phi_vec]=func_calc_phi(L,n);

    [p] = func_calc_filter_coefs(L);
    
    for II = 1:(L-2)
        temp = find((x>0.99999*II)&(x<1.00001*II));
        phi(temp) = phi_vec(II);
        clear temp
    end
    clear phi_vec
    
    
    kVec = (1:2:((2^tempInc)*(L-1)-1))';
    for JJ = 1:tempInc
        jVal = JJ;
        for KK = 1:length(kVec)
            kVal = kVec(KK);
            xVal = kVal/2^jVal;
            tempPhi = 0;
            for LL = 0:(L-1)
                lVal = LL;
                phiIndex = kVal/2^(jVal-1) - lVal;
                if (phiIndex>0)&(phiIndex<(L-1))
                    temp = find((x>0.99999*phiIndex)&(x<1.00001*phiIndex));
                    tempPhi = tempPhi + (2^n)*p(lVal+1)*phi(temp);
                end
                clear lVal phiIndex temp
            end
            temp = find((x>0.99999*xVal)&(x<1.00001*xVal));
            phi(temp) = tempPhi;
            clear temp tempPhi kVal xVal
        end
        clear jVal
    end
    clear kVec
    
    if length(phi) > 2^tot
        wraps = round(length(phi)/2^tot);
        for II = 1:wraps
            if II == 1
                phiNew = phi(1:2^tot);
            else
                phiNew = phiNew + phi((II-1)*2^tot+(1:2^tot));
            end
        end
        clear phi
        phi = phiNew;
        clear phiNew
    end
    
    if length(phi) < 2^tot
        typ = zeros(2^tot,1);
        typ(1:length(phi)) = phi;
        clear phi
        phi = typ;
    end
    
    for II = 1:2^J
        phiMat(:,II) = circshift(phi,(II-1)*2^(tot-J));
    end
    
    eval(['P' num2str(J) '=phiMat;'])
    clear II JJ KK LL phi phiMat temp* wraps x
end

x = (0:1/2^tot:(1-1/2^tot))';
P0 = ones(size(P1,1),1);

savename = sprintf('DB%i_n%i_SF',L,n);
save(savename,'P*','x')
